/*
  Copyright (c) 2004-2007 The FlameRobin Development Team

  Permission is hereby granted, free of charge, to any person obtaining
  a copy of this software and associated documentation files (the
  "Software"), to deal in the Software without restriction, including
  without limitation the rights to use, copy, modify, merge, publish,
  distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to
  the following conditions:

  The above copyright notice and this permission notice shall be included
  in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


  $Id: UsernamePasswordDialog.h 1538 2007-11-12 19:55:43Z mghie $

*/

#ifndef USERNAMEPASSWORDDIALOG_H
#define USERNAMEPASSWORDDIALOG_H
//-----------------------------------------------------------------------------
#include <wx/wx.h>

#include "gui/BaseDialog.h"
//-----------------------------------------------------------------------------
class UsernamePasswordDialog: public BaseDialog {
private:
    wxStaticText* labelDescriptionM;
    wxStaticText* labelUsernameM;
    wxTextCtrl* textUsernameM;
    wxStaticText* labelPasswordM;
    wxTextCtrl* textPasswordM;
    wxButton* buttonOkM;
    wxButton* buttonCancelM;

    void layoutControls();
    void updateButton();

    void OnSettingsChange(wxCommandEvent& event);
public:
    UsernamePasswordDialog(wxWindow* parent, const wxString& title,
        const wxString& username, bool usernameIsFixed = true,
        const wxString& description = wxEmptyString);

    wxString getUsername();
    wxString getPassword();
};
//-----------------------------------------------------------------------------
#endif // USERNAMEPASSWORDDIALOG_H
