/*
  Copyright (c) 2004-2007 The FlameRobin Development Team

  Permission is hereby granted, free of charge, to any person obtaining
  a copy of this software and associated documentation files (the
  "Software"), to deal in the Software without restriction, including
  without limitation the rights to use, copy, modify, merge, publish,
  distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to
  the following conditions:

  The above copyright notice and this permission notice shall be included
  in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


  $Id: DataGrid.h 1487 2007-10-25 13:43:38Z mghie $

*/

#ifndef FR_DATAGRID_H
#define FR_DATAGRID_H
//----------------------------------------------------------------------
#include <wx/wx.h>
#include <wx/grid.h>

class DataGridTable;
//----------------------------------------------------------------------
class DataGrid: public wxGrid
{
private:
    void copyToClipboard(const wxString cbText);
    void extendSelection(int direction);
    void notifyIfUnfetchedData();
    void showPopMenu(wxPoint cursorPos);
    void updateRowHeights();
public:
    DataGrid(wxWindow* parent, wxWindowID id);
    ~DataGrid();

    DataGridTable* getDataGridTable();
    void fetchData(wxMBConv* conv);
private:
    void OnContextMenu(wxContextMenuEvent& event);
    void OnGridCellRightClick(wxGridEvent& event);
    void OnGridLabelRightClick(wxGridEvent& event);
    void OnIdle(wxIdleEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnMouseWheel(wxMouseEvent& event);
    void OnThumbRelease(wxScrollWinEvent& event);
    void OnEditorCreated(wxGridEditorCreatedEvent& event);
    void OnEditorKeyDown(wxKeyEvent& event);
    DECLARE_EVENT_TABLE()
public:
    void copyToCB();
    void copyToCBAsInsert();
    void copyToCBAsUpdate();
    void saveAsHTML();
    void saveAsCSV();

    void setHeaderFont();
    void setCellFont();

    void cancelFetchAll();
    void fetchAll();
};
//----------------------------------------------------------------------
#endif
